const EXPORTED_SYMBOLS = ['getRequest', 'replaceCore'];

Components.utils.import("resource://migre-me-hultmann-modules/util.js");

function getRequest(window) {
  var req = new AsyncRequest();
  var started;

  req.onStart = function() {
    window.setCursor('progress');
    started = new Date().getTime();
    /*
    var e = window.document.documentElement;
    util.log('onstart ['+e.className+']');
    e.className = (e.className ? " " : "") + 'migreme-hltmnn-progress';

    //window.window.gBrowser.selectedBrowser.defaultView.setCursor('progress');

    e = window.gBrowser.selectedBrowser.contentDocument.body;
    util.log('onstart ['+e.className+']');
    e.className = (e.className ? " " : "") + 'migreme-hltmnn-progress';
    */
  };

  req.onStop = function() {
    var span = new Date().getTime() - started;
    util.log('migre.me connection: '+span+'ms');
    /*
    var e = window.document.documentElement;
    util.log('onstop ['+e.className+']');
    var t = e.className.split(/\s+/).map(function(i) {
      return i == 'migreme-hltmnn-progress' ? '' : i;
    });
    e.className = t.join(' ');
    */
    //util.log('cursor auto');
    window.setCursor('auto');
  };

  req.onError = function(errData) {
    var buildLog = function() {
      var x = errData.xhr;
      return 'GET ' + req.requestUrl + '\n====================8<-----------------\n' +
             x.status + ' ' + x.statusText + '\n' +
             x.getAllResponseHeaders() + '\n' +
             x.responseText;
    }


    var label = util.getText('notification.response.label', []);

    switch (errData.id) {
      case 0:
        showNotification(window, util.getText('notification.connection.label', []), null, null);
        break;
      case 1:
        showNotification(window, label, util.getText('error.response.details.status', []), buildLog());
        break;
      case 2:
        showNotification(window, label, util.getText('error.response.details.generic', []), buildLog());
        break;
      case 3:
        showNotification(window, label, util.getText('error.response.details.xml', []), buildLog());
        break;
      case 4:
        showNotification(window, label, util.getText('error.response.details.nodata', []), buildLog());
        break;
      case 5:
        showNotification(window, util.getText('notification.request.compress.label', [errData.msg]), null, null);
        break;
      case 6:
        showNotification(window, util.getText('notification.request.uncompress.label', [errData.msg]), null, null);
        break;
      default:
        throw 'bug';
    }
  }

  return req;
}


function showNotification(chromeWnd, msg, error, txtLog) {
  var buttonConfig = null;
  if (error !== null) {
    buttonConfig = [{
      callback: function(evt) {
        var params = {
          title: util.getText('error.response.details.title', []),
          close: util.getText('error.response.details.close.label', []),
          label: error,
          description: txtLog
        };
        chromeWnd.openDialog('chrome://migre-me-hultmann/content/warning.xul',
                          '',
                          'chrome,centerscreen,modal',
                          params);
        return true;
      },
      label: util.getText('notification.button.label', []),
      accessKey: util.getText('notification.button.accesskey', [])
    }];
  }

  var box = chromeWnd.gBrowser.getNotificationBox(chromeWnd.gBrowser.selectedBrowser);
  var notif = box.appendNotification(
                  msg,
                  'migre-me-hultmann-warning',
                  'chrome://browser/skin/Info.png',
                  box.PRIORITY_WARNING_MEDIUM,
                  buttonConfig);
}




function AsyncRequest() {
  this.requestUrl = null;
  this.onError = null;
  this.onSuccess = null;
  this.onStart = null;
  this.onStop = null;
}

AsyncRequest.prototype.createUrl = function(uri) {
  //this.requestUrl = "http://localhost:81/migreme.xml?url="+ uri.spec;// + '&xxx=a b ç';
  this.requestUrl = "http://migre.me/api.xml?url="+ encodeURIComponent(uri.spec);

  var xhr = this._createXhr();
  var me = this;
  xhr.onload = function(evt) {
    me.requestSuccess(this); // this == evt.target == evt.currentTarget == xhr;
  }
  xhr.onerror = function(evt) {
    me.requestFail(this);
  }
  xhr.send(null);
  this.onStart();
};

AsyncRequest.prototype.expand = function(uri) {
  this.requestUrl = "http://migre.me/api_redirect.xml?url="+ encodeURIComponent(uri.spec);// + '&xxx=a b ç';
  var xhr = this._createXhr();
  var me = this;
  xhr.onload = function(evt) {
    me.requestSuccess(this); // this == evt.target == evt.currentTarget == xhr;
  }
  xhr.onerror = function(evt) {
    me.requestFail(this);
  }
  xhr.send(null);
  this.onStart();
};


AsyncRequest.prototype._createXhr = function() {
  var item = Components
              .classes['@mozilla.org/extensions/manager;1']
              .getService(Components.interfaces.nsIExtensionManager)
              .getItemForID('migre.me@hultmann');
  var userAgent = item.name + '/' + item.version;

  
  var xhr = Components
              .classes['@mozilla.org/xmlextras/xmlhttprequest;1']
              .createInstance(Components.interfaces.nsIXMLHttpRequest);

  xhr.open("GET", this.requestUrl, true);
  xhr.setRequestHeader("Accept-Language", null);
  xhr.setRequestHeader("Cookie", null);
  xhr.setRequestHeader("Accept", "text/xml");
  xhr.setRequestHeader("User-Agent", userAgent);
  // LOAD_ONLY_IF_MODIFIED makes xhr results from cache be empty!
  //xhr.channel.loadFlags |= Components.interfaces.nsICachingChannel.LOAD_ONLY_IF_MODIFIED;
  return xhr;
};


AsyncRequest.prototype.requestFail = function(xhr) {
  this.onStop();
  var errorData = {
    id: 0,
    xhr: xhr,
    msg: null
  };
  this.onError(errorData, xhr);
};


AsyncRequest.prototype.requestSuccess = function(xhr) {
  this.onStop();
  var errorData = {
    id: 0,
    xhr: xhr,
    msg: null
  };

  if (xhr.status !== 200) {
    errorData.id = 1;
    this.onError(errorData);
    return;
  }

  var doc = xhr.responseXML;
  if (doc === null) {
    errorData.id = 2;
    this.onError(errorData);
    return;
  }


  if (doc.documentElement.namespaceURI === 'http://www.mozilla.org/newlayout/xml/parsererror.xml') {
    errorData.id = 3;
    this.onError(errorData);
    return;
  }


  var responseData = this.populateResponseData(doc);


  if (this.requestUrl.indexOf("http://migre.me/api_redirect.xml") === 0) {

    if (this.validateUncompressResponse(responseData, errorData)) {
      this.onSuccess(responseData.url);
    } else {
      this.onError(errorData);
    }

  } else {

    if (this.validateCompressResponse(responseData, errorData)) {
      this.onSuccess(responseData.migre);
    } else {
      this.onError(errorData);
    }
  }
};


AsyncRequest.prototype.validateCompressResponse = function(responseData, errorData) {
  if (responseData.error === null) {
    errorData.id = 4;
    return false;
  }
  if (responseData.error !== '0') {
    errorData.id = 5;
    errorData.msg = responseData.errormessage === null ? '' : responseData.errormessage;
    return false;
  }

  if (responseData.migre === null) {
    errorData.id = 4;
    return false;
  }

  return true;
};


AsyncRequest.prototype.validateUncompressResponse = function(responseData, errorData) {
  if (responseData.error === null) {
    errorData.id = 4;
    return false;
  }
  if (responseData.error !== '0') {
    errorData.id = 6;
    errorData.msg = responseData.errormessage === null ? '' : responseData.errormessage;
    return false;
  }

  if (responseData.url === null) {
    errorData.id = 4;
    return false;
  }

  return true;
};


AsyncRequest.prototype.populateResponseData = function(doc) {
  var rv = {
    error: null,
    errormessage: null,
    migre: null,
    url: null
  };

  var rvObj  = [      'error',       'errormessage',       'migre',       'url'];
  var xmlObj = ['/item/error', '/item/errormessage', '/item/migre', '/item/url'];


  var xmlValues = xmlObj.map(function(query) {
    var type = Components.interfaces.nsIDOMXPathResult.ANY_TYPE;
    return doc.evaluate(query, doc, null, type, null).iterateNext();
  });

  rvObj.forEach(function(val, idx) {
    if (xmlValues[idx] !== null) {
      rv[val] = xmlValues[idx].textContent;
    }
  });

  return rv;
};



function replaceCore(cmdData, newTxt) {
  var pos = 'rows' in cmdData.node ? cmdData.node.scrollTop : -1;
  replaceCore2(cmdData, newTxt);
  if (pos > -1) {
    cmdData.node.scrollTop = pos;
  }
}

function replaceCore2(cmdData, newTxt) {
  var txt = cmdData.node.value;

  if (cmdData.selectionStart !== cmdData.selectionEnd) {
    //replace selection
    cmdData.node.value = txt.substr(0, cmdData.selectionStart) + newTxt + txt.substr(cmdData.selectionEnd);
    cmdData.node.setSelectionRange(cmdData.selectionStart, cmdData.selectionStart + newTxt.length);
    return;
  }


  var idxStart = 0;

  do {
    var idxUrl = txt.indexOf(cmdData.typed, idxStart);
    if (idxUrl > -1) {
      var wordIdx = util.findCurrentUrlPos(txt, idxUrl);
      var urlFound = txt.substr(wordIdx[0], wordIdx[1]);
      //util.log('found ['+wordIdx[0]+', '+wordIdx[1]+' '+urlFound+']');
      if (urlFound === cmdData.typed) {
        txt = txt.substr(0, wordIdx[0]) + newTxt + txt.substr(wordIdx[0] + wordIdx[1]);
        idxStart = wordIdx[0] + newTxt.length;
      } else {
        //util.log('NOT replaced\n'+urlFound +' != '+ cmdData.typed);
        idxStart = wordIdx[0] + wordIdx[1];
      }
    }
  } while (idxUrl > -1);


  cmdData.node.value = txt;
  cmdData.node.setSelectionRange(idxStart, idxStart);
}
